"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime-corejs2/regenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/slicedToArray"));

var _entries = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/entries"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/asyncToGenerator"));

var _inert = _interopRequireDefault(require("inert"));

var _vision = _interopRequireDefault(require("vision"));

var _hapiReactViews = _interopRequireDefault(require("hapi-react-views"));

function _default(_x, _x2) {
  return _ref2.apply(this, arguments);
}

function _ref2() {
  _ref2 = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(server, _ref) {
    var views, staticConfig, routes, logger;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            views = _ref.views, staticConfig = _ref.static, routes = _ref.routes, logger = _ref.logger;
            _context.next = 3;
            return _promise.default.all([server.register(_inert.default), server.register(_vision.default)]);

          case 3:
            if (views) {
              /* Configure view engine to use React */
              server.views({
                engines: (0, _objectSpread2.default)({
                  jsx: _hapiReactViews.default,
                  js: _hapiReactViews.default
                }, views.engines),
                path: views.dir,
                defaultExtension: 'js'
              });
              /* Register view routes */

              if (views.paths) {
                (0, _entries.default)(views.paths).forEach(function (_ref3) {
                  var _ref4 = (0, _slicedToArray2.default)(_ref3, 2),
                      path = _ref4[0],
                      view = _ref4[1];

                  server.route({
                    method: 'GET',
                    path: path,
                    handler: {
                      view: view
                    }
                  });
                });
              } else if (logger) {
                logger.warn('View Engine initialized with no views');
              }
            }
            /* Route for serving static files */


            if (staticConfig && staticConfig.enabled) {
              server.route({
                method: 'GET',
                path: "".concat(staticConfig.path, "/{param*}"),
                handler: {
                  directory: {
                    path: staticConfig.dir
                  }
                }
              });
            }
            /* Custom routes */


            if (routes) {
              routes.forEach(function (route) {
                return server.route(route);
              });
            }

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _ref2.apply(this, arguments);
}

module.exports = exports.default;